
# charged player
#execute as @a[scores={nbenergy=1..}] at @s run function nbauto:chargedplayer
#execute as @s[scores={nbenergyneeded=1..}] run scoreboard players remove @s nbenergyneeded 10


# teleporter basic stuff

execute as @e[type=item,nbt={Item:{id:"minecraft:ender_pearl",count:1}}] at @s if block ~ ~-1 ~ crying_obsidian align xyz run function nbauto:teleporter/create
execute as @e[type=item_display,tag=teleporter] at @s run function nbauto:teleporter/checkduplicate
execute as @e[type=#nbauto:machine,tag=teleporter] at @s unless block ~ ~ ~ crying_obsidian run function nbauto:teleporter/destroy

# teleporter unique behavior
execute as @e[type=item_display,tag=teleporter,tag=teleporter_set,scores={nbenergy=500..}] at @s if entity @p[scores={teleportcooldown=0..},distance=..2,predicate=nbauto:pressing_sneak] run function nbauto:teleporter/teleportsetup

#transformer basic stuff
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_block",count:1}}] at @s if block ~ ~-1 ~ redstone_lamp align xyz run function nbauto:transformer/create
execute as @e[type=block_display,tag=nbauto_transformer,tag=!nbmachine_visual] at @s run function nbauto:transformer/checkduplicate
execute as @e[type=block_display,tag=nbauto_transformer] at @s unless block ~ ~ ~ redstone_lamp run function nbauto:transformer/destroy

# electricity warper basic stuff
execute as @e[type=item,nbt={Item:{id:"minecraft:lightning_rod",count:1}}] at @s if block ~ ~ ~ sculk_shrieker[can_summon=false] align xyz run function nbauto:electricitywarper/create
execute as @e[type=item_display,tag=nbauto_elec_warper] at @s run function nbauto:electricitywarper/checkduplicate
execute as @e[type=item_display,tag=nbauto_elec_warper] at @s unless block ~ ~ ~ sculk_shrieker[can_summon=false] run function nbauto:electricitywarper/destroy

# electricity warper unique behavior
execute as @e[type=item_display,tag=nbauto_elec_warper,tag=nbauto_elec_warper_set,scores={nbenergy=1..}] at @s run function nbauto:electricitywarper/warp


# |Original Plans|
# quarry comming soon
# stonecutter + diamond pick = quarry
# on right click of the stone cutter's top you will get an item that will determine where the quarry will mine
# once area is set you can give the quarry power to start excavation
# if you right click when the quarry already has a specified area it will give a visual indicator of the area
# if left clicked it will reset its mining area
# Idk if this will happen but it might be able to chunck load its mining area until it is finished but that seems a bit difficult
# when the quarry is done it will forget it's mining area


# quarry basic stuff
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_pickaxe",count:1}}] at @s if block ~ ~ ~ stonecutter align xyz run function nbauto:quarry/place
execute as @e[type=item_display,tag=quarry] at @s run function nbauto:quarry/checkduplicate
execute as @e[type=item_display,tag=quarry] at @s unless block ~ ~ ~ stonecutter run function nbauto:quarry/destroy
# quarry unique behavior
execute as @a[nbt=!{Inventory:[{components:{"minecraft:custom_data":{QuarrySetter:1}}}]}] at @s if entity @e[type=item_display,tag=quarry,scores={nbQuarrySet=0},distance=..1,limit=1] run function nbauto:quarry/giveposset1
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=1}] if score @s nbenergyneeded <= @s nbenergy at @s run function nbauto:quarry/startmining
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=1}] if score @s nbenergyneeded > @s nbenergy at @s run title @a[distance=...5] actionbar [{"text":"Energy: "},{"score":{"name":"@s","objective":"nbenergy"}},{"text":" / "},{"score":{"name":"@s","objective":"nbenergyneeded"}}]
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=0}] at @s run title @a[distance=...5] actionbar [{"text":"Energy: "},{"score":{"name":"@s","objective":"nbenergy"}}]

kill @e[type=block_display,tag=quarryareavisual]
execute as @a[predicate=nbauto:quarrytweak] at @s run function nbauto:quarry/tweakarea/main

#quarry miner entity
execute as @e[type=armor_stand,tag=quarryminer,limit=10,sort=random] at @s run function nbauto:quarry/miner/main


# next function

schedule function nbauto:20tick-1 5t